import datetime

class Job():
    def __init__(self, pid, cpu_req, status):
        self._pid = pid
        self._cpucycle = cpu_req
        self._status = status
    
    def __str__(self):
        return f'pid: {self._pid} | size: {self._cpucycle} | status: {self._status}'

class Scheduler():
    def __init__(self):
        self._timestamp = datetime.datetime.now()
        print(f"\n[INFO] {self._timestamp.strftime('%Y-%m-%d %H:%M:%S')} -> scheduler starting...")
    
    def get_shortest(self, jobs):
        return min(jobs, key=lambda x: x._cpucycle)
    
    def run_queue(self, job_queue):
        cycle = 0
        while job_queue:
            active_job = self.get_shortest(job_queue)

            print(f"\nshortest job in queue: {active_job}\n")
            print(f"starting execution: pid {active_job._pid}".center(44, '-'))
            
            active_job._status = 'active'

            while active_job._cpucycle > 0:
                cycle += 1
                active_job._cpucycle -= 1
                print (f"cpu cycle: {cycle}")
                print (active_job)
            
            print(f"finished execution: pid {active_job._pid}".center(44, '-') + '\n')
            print(f"changing status: pid {active_job._pid}".center(44, '-'))
            active_job._status = 'inactive'
            print(active_job)
            print(f"removing job: pid {active_job._pid} from queue".center(44, '-'))
            job_queue.remove(active_job)


p0 = Job(2, 2, 'inactive')
p1 = Job(3, 3, 'inactive')
p2 = Job(1, 1, 'inactive')
p3 = Job(4, 4, 'inactive')
p4 = Job(5, 5, 'inactive')
jobs = [p0, p1, p2, p3, p4]
schedule = Scheduler()
schedule.run_queue(jobs)
print('\nJobs complete')